=== modified file 'src/com/goldencode/p2j/uast/ParameterKey.java'
--- old/src/com/goldencode/p2j/uast/ParameterKey.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/ParameterKey.java	2022-05-20 12:39:21 +0000
@@ -4,11 +4,13 @@
 **
 ** Copyright (c) 2018-2022, Golden Code Development Corporation.
 **
-** -#- -I- --Date-- ---------------------------------------Description----------------------------------------
+** -#- -I- --Date-- --------------------------------------Description---------------------------------------
 ** 001 CA  20181229 First version.
 ** 002 CA  20190423 WrappedResource must be treated as a handle type.  Normalized DataSet type's case.
-** 003 CA  20190508 Changes to solve collisions in converted Java signature collisions for overloaded methods.
+** 003 CA  20190508 Changes to solve collisions in converted Java signature collisions for overloaded 
+**                  methods.
 ** 004 CA  20220516 Fixed 'toJava' for OO extent parameters.
+**     GES 20220520 Added typeEquivalent(), other helpers and the way Java types are rendered.
 */
 
 /*
@@ -75,8 +77,6 @@
 /**
  * Container for a parameter's key, including its data type and mode.  Used both at caller and
  * at the OO method definition.
- * 
- * TODO: table parameters are matched via the temp-table's field types
  */
 public class ParameterKey
 {
@@ -110,6 +110,91 @@
    }
    
    /**
+    * Create a new parameter key.
+    * 
+    * @param    lparam
+    *           The legacy parameter annotation.
+    */
+   public ParameterKey(LegacyParameter lparam)
+   {
+      String pmode = lparam.mode();
+      
+      if ("INPUT".equalsIgnoreCase(pmode))
+      {
+         this.mode = KW_INPUT;
+      }
+      else if ("OUTPUT".equalsIgnoreCase(pmode))
+      {
+         this.mode = KW_OUTPUT;
+      }
+      else if ("INPUT-OUTPUT".equalsIgnoreCase(pmode))
+      {
+         this.mode = KW_IN_OUT;
+      }
+      else if ("RETURN".equalsIgnoreCase(pmode))
+      {
+         this.mode = KW_RETURN;
+      }
+      else
+      {
+         this.mode = UNKNOWN_TOKEN;
+      }
+
+      String txt = lparam.type();
+      
+      if ("bdt".equalsIgnoreCase(txt))
+      {
+         // OO legacy classes which have POLY parameters have BDT as their type, at the Java implementation.
+         txt = "Object";
+      }
+      
+      if (!lparam.qualified().isEmpty())
+      {
+         txt += "<? extends " + lparam.qualified().toLowerCase() + ">";
+      }
+      else if ("object".equalsIgnoreCase(lparam.type()))
+      {
+         txt += "<? extends progress.lang.object>";
+      }
+      
+      if (lparam.extent() == -1)
+      {
+         txt += "[]";
+      }
+      else if (lparam.extent() != -2)
+      {
+         txt += "[" + lparam.extent() + "]";
+      }
+      
+      this.type = txt;
+   }
+   
+   /**
+    * Report if the type of the two parameters is the same. The mode is not considered.
+    * 
+    * @param    other
+    *           The instance to compare against.
+    *           
+    * @return   {@code true} if the types are the same or are both {@code null}.  If they are different
+    *           (including if only one is {@code null}) then {@code false} will be returned. 
+    */
+   public boolean typeEquivalent(ParameterKey other)
+   {
+      return Objects.equals(this.type, other.type);
+   }
+   
+   /**
+    * Report the type without any encoded extent.
+    * 
+    * @return   The type with any extent portion removed. 
+    */
+   public String scalarType()
+   {
+      int idx = type.indexOf('[');
+      return (idx < 0) ? type : type.substring(0, idx);
+   }
+   
+   /**
     * Test {@code other} object for equality.
     * 
     * @param   other
@@ -124,14 +209,15 @@
       {
          return true;
       }
-      if (other == null || getClass() != other.getClass())
+      
+      if (other == null || !(other instanceof ParameterKey))
       {
          return false;
       }
       
       ParameterKey otherKey = (ParameterKey) other;
       
-      return Objects.equals(this.mode, otherKey.mode) && Objects.equals(this.type, otherKey.type);
+      return Objects.equals(this.mode, otherKey.mode) && typeEquivalent(otherKey);
    }
    
    /**
@@ -157,7 +243,17 @@
    @Override
    public String toString()
    {
-      return (mode == null ? "" : ProgressParser.lookupTokenName(mode)) + " " + type;
+      return renderMode() + " " + type;
+   }
+
+   /**
+    * Describe the instance as a 4GL parameter.
+    * 
+    * @return   See above.
+    */
+   public String render()
+   {
+      return renderMode() + " " + renderType();
    }
 
    /**
@@ -176,39 +272,117 @@
     * @return    See above.
     */
    public String toJava()
-   {
-      // TODO: some of these calls must be marked as 'dynamic'??
-
+   {      
+      String t = type.toLowerCase();
+      
+      // "dataset <signature>"
+      if (t.startsWith("dataset "))
+      {
+         switch (mode)
+         {
+            case KW_INPUT:
+               return "InputDataSetParameter";
+            case KW_OUTPUT:
+               return "OutputDataSetParameter";
+            case KW_IN_OUT:
+               return "InputOutputDataSetParameter";
+         }
+      }
+
+      if (t.equals("dataset-handle"))
+      {
+         switch (mode)
+         {
+            case KW_INPUT:
+               return "InputDataSetHandle";
+            case KW_OUTPUT:
+               return "OutputDataSetHandle";
+            case KW_IN_OUT:
+               return "InputOutputDataSetHandle";
+         }
+      }
+      
+      // "temp-table <signature>"
+      if (t.startsWith("temp-table "))
+      {
+         switch (mode)
+         {
+            case KW_INPUT:
+               return "InputTableParameter";
+            case KW_OUTPUT:
+               return "OutputTableParameter";
+            case KW_IN_OUT:
+               return "InputOutputTableParameter";
+         }
+      }
+
+      if (t.equals("table-handle"))
+      {
+         switch (mode)
+         {
+            case KW_INPUT:
+               return "InputTableHandle";
+            case KW_OUTPUT:
+               return "OutputTableHandle";
+            case KW_IN_OUT:
+               return "InputOutputTableHandle";
+         }
+      }
+      
+      // we must process the "dataset <...|int[]>" and "temp-table <...|int[]>" cases above first; by
+      // the time we get here, we are dealing with BDT cases only
       if (type.indexOf('[') > 0)
       {
-         switch (mode.intValue())
+         switch (mode)
          {
             case KW_INPUT:
                return type.startsWith("object") 
                         ? "object[]" 
                         : type.substring(0, type.indexOf('[')) + "[]"; // extent is lost
             case KW_OUTPUT:
-               return OutputExtentParameter.class.getSimpleName();
+               return "OutputExtentParameter";
             case KW_IN_OUT:
-               return InputOutputExtentParameter.class.getSimpleName();
+               return "InputOutputExtentParameter";
          }
       }
       
-      if (type.startsWith("object"))
-      {
-         return object.class.getSimpleName();
-      }
-      
-      if (type.equalsIgnoreCase("dataset") || type.equalsIgnoreCase("dataset-handle"))
-      {
-         return DataSetParameter.class.getSimpleName();
-      }
-
-      if (type.equalsIgnoreCase("temp-table") || type.equalsIgnoreCase("table-handle"))
-      {
-         return TableParameter.class.getSimpleName();
-      }
-      
+      if (t.startsWith("object"))
+      {
+         return "object";
+      }
+            
       return type;
    }
+   
+   /**
+    * Get a string representation of the mode.
+    * 
+    * @return   The mode.
+    */
+   private String renderType()
+   {
+      String text = type;
+      
+      // note the trailing space, it is important to avoid matching "DATASET-HANDLE"
+      if (type.startsWith("DATASET "))
+      {
+         text = "DATASET";
+      }
+      else if (type.startsWith("TEMP-TABLE"))
+      {
+         text = "TEMP-TABLE";
+      }
+      
+      return text;
+   }
+   
+   /**
+    * Get a string representation of the mode.
+    * 
+    * @return   The mode.
+    */
+   private String renderMode()
+   {
+      return mode == null ? "" : ProgressParser.lookupTokenName(mode);
+   }   
 }

=== modified file 'src/com/goldencode/p2j/uast/ScanDriver.java'
--- old/src/com/goldencode/p2j/uast/ScanDriver.java	2022-05-01 17:28:59 +0000
+++ new/src/com/goldencode/p2j/uast/ScanDriver.java	2022-05-16 20:54:31 +0000
@@ -66,6 +66,7 @@
 **                           profiles to be ran at once, with the conversion switching the state between 
 **                           profiles, when a resource (like a file or namespace) is being processed.  Only
 **                           front phase is supported at this time.
+**     GES 20220516          Avoid duplicate parsing caused by recursive parsing of classes.
 */
 
 /*
@@ -368,19 +369,25 @@
                
                try
                {
+                  boolean exists = AstManager.get().isExistingAst(AstGenerator.getAstName(fileName));
+                  
                   if (!silent && singleThreaded)
                   {
-                     System.out.println(fileName);
-                  }
-                  
-                  // process the file, note that for HTML files the file list
-                  // may be edited to remove the output file name that the E4GL
-                  // preprocessor generates, if it is separately listed in
-                  // the list (this avoids duplicate processing of that file
-                  // since it was already processed fully to an AST when it was
-                  // listed as an HTML file, it doesn't need to be processed
-                  // again)
-                  gen.processFile(fileName, safeList, index);
+                     System.out.printf("%s%s\n", fileName, exists ? " (already parsed)" : "");
+                  }
+
+                  // only parse if the file has not been recursively parsed already
+                  if (!exists)
+                  {
+                     // process the file, note that for HTML files the file list
+                     // may be edited to remove the output file name that the E4GL
+                     // preprocessor generates, if it is separately listed in
+                     // the list (this avoids duplicate processing of that file
+                     // since it was already processed fully to an AST when it was
+                     // listed as an HTML file, it doesn't need to be processed
+                     // again)
+                     gen.processFile(fileName, safeList, index);
+                  }
                }
                catch(Exception exc)
                {

